/*!    
 * Copyright (c) 2014 ENEO Tecnología S.L.
 * This file is part of redBorder.
 * redBorder is free software: you can redistribute it and/or modify
 * it under the terms of the GNU Affero General Public License as published by
 * the Free Software Foundation, either version 3 of the License, or
 * (at your option) any later version.
 * redBorder is distributed in the hope that it will be useful,
 * but WITHOUT ANY WARRANTY; without even the implied warranty of
 * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
 * GNU Affero General Public License for more details.
 * You should have received a copy of the GNU Affero General Public License
 * along with redBorder. If not, see <http://www.gnu.org/licenses/>.
 */

$(document).on('click', 'article#yara_rules input[type=checkbox].rule-select-all', function(e){

  if ($(this).prop("checked")) {
    $('article#yara_rules input[type=checkbox]').prop('checked', true);
  } else {
    $('article#yara_rules input[type=checkbox]').prop('checked', false);
  }

});

$(document).on('click', 'article#yara_rules li.category input[type=checkbox]', function(e){

  var category_id = $(this).parents("li.category").attr("data-category"); 

  if ($(this).prop("checked")) {
    $('article#yara_rules li[data-category='+ category_id +']:not(.category) input[type=checkbox]').prop('checked', true);

  } else {
    $('article#yara_rules li[data-category='+ category_id +'] input[type=checkbox]').prop('checked', false);
    $('article#yara_rules input[type=checkbox].rule-select-all').prop('checked', false);
  }

});

$(document).on('click', 'article#yara_rules li.group input[type=checkbox]', function(e){

  var category_id = $(this).parents("li.group").attr("data-category");
  var group_id    = $(this).parents("li.group").attr("data-group");

  if ($(this).prop("checked")) {
    $('article#yara_rules li[data-category='+ category_id +'][data-group='+ group_id +']:not(.group) input[type=checkbox]').prop('checked', true);
  } else {
    $('article#yara_rules li[data-category='+ category_id +'][data-group='+ group_id +'] input[type=checkbox]').prop('checked', false);
    $('article#yara_rules input[type=checkbox].rule-select-all').prop('checked', false);
    $('article#yara_rules li.category[data-category='+ category_id +'] input[type=checkbox]').prop('checked', false);
  }

});

$(document).on('click', 'article#yara_rules li.family input[type=checkbox]', function(e){

  var category_id = $(this).parents("li.family").attr("data-category");
  var group_id    = $(this).parents("li.family").attr("data-group");
  var family_id   = $(this).parents("li.family").attr("data-family");

  if ($(this).prop("checked")) {
    $('article#yara_rules li[data-category='+ category_id +'][data-group='+ group_id +'][data-family='+ family_id +']:not(.family) input[type=checkbox]').prop('checked', true);
  } else {
    $('article#yara_rules li[data-category='+ category_id +'][data-group='+ group_id +'][data-family='+ family_id +'] input[type=checkbox]').prop('checked', false);
    $('article#yara_rules input[type=checkbox].rule-select-all').prop('checked', false);
    $('article#yara_rules li.category[data-category='+ category_id +'] input[type=checkbox]').prop('checked', false);
    $('article#yara_rules li.group[data-category='+ category_id +'][data-group='+ group_id +'] input[type=checkbox]').prop('checked', false);
  }

});

$(document).on('click', 'article#yara_rules li.rule input[type=checkbox]', function(e){

  var category_id = $(this).parents("li.rule").attr("data-category");
  var group_id    = $(this).parents("li.rule").attr("data-group");
  var family_id   = $(this).parents("li.rule").attr("data-family");

  if (!$(this).prop("checked")) {
    $('article#yara_rules input[type=checkbox].rule-select-all').prop('checked', false);
    $('article#yara_rules li.category[data-category='+ category_id +'] input[type=checkbox]').prop('checked', false);
    $('article#yara_rules li.group[data-category='+ category_id +'][data-group='+ group_id +'] input[type=checkbox]').prop('checked', false);
    $('article#yara_rules li.family[data-category='+ category_id +'][data-group='+ group_id +'][data-family='+ family_id +'] input[type=checkbox]').prop('checked', false);
  }

});

$(document).on('click', 'article#yara_rules .action ul.dropdown-menu a', function(e){

  var self = $(this);
  var parent = $(self).parents('li.rule, li.filetype, li.maltype');

  var filetype_name = $(parent).data("filetype_name");
  var maltype_name    = $(parent).data("maltype_name");

  if(!parent.hasClass('rule')){
    var text = 'article#yara_rules li';
    if(filetype_name){text += '[data-filetype_name="'+ filetype_name +'"]'}
    if(maltype_name){text += '[data-maltype_name="'+ maltype_name +'"]'}

    parent = $(text);
  }

  parent.find('div.action .dropdown').hide();
  parent.find('div.action').append("<i class='fa fa-spinner fa-spin'></i>");

});

$(document).on('click', 'body.rules.index ul.dropdown-menu.actions a', function(e){
  var action_id = $(this).attr('data-action-id');
  var msg = $(".navbar-buttons input#msg").val();

  $("form#massive_update input#action_id").val(action_id);
  $("form#massive_update input#msg").val(msg);

  $("form#massive_update").submit();

  return false;
});